# Set Version
VERSION = "0.1.0"

 
require 'httparty'
require 'base64'
require 'time'
require 'nokogiri'

module Nzcoapi
	include HTTParty
	include Nokogiri
	base_uri "http://www.businessdata.govt.nz"
	format :xml

	@@access_key = "J5zFrdfHu5Bbg2iw"
	@@secret_key = "fin39USzsZGHSJGVUwzkUJWgL2yUDQ1C0n6NBtv2"
	@@timestamp = Time.now.rfc2822 + " GMT"
	headers "Timestamp" => Time.now.rfc2822 + " GMT"
  	headers "Access" => @@access_key
  	headers 'Accept' => "application/xml"


	def self.search_for_company(string)
		headers "Timestamp" => Time.now.rfc2822 + " GMT"
		@@timestamp = Time.now.rfc2822 + " GMT"

		stringtosign = "GET" + "\n" + "www.businessdata.govt.nz" + "\n" + "/data/app/ws/rest/companies/entity/search/v2.0/#{string}" + "\n" + @@timestamp + "\n" + @@access_key + "\n" + "application/xml" + "\n"

		headers "Authorization" => @@access_key + ":" + Base64.strict_encode64(OpenSSL::HMAC.digest('sha256', @@secret_key, stringtosign))
		headers "Timestamp" => Time.now.rfc2822 + " GMT"

		Nokogiri::XML((get("/data/app/ws/rest/companies/entity/search/v2.0/#{string}").body), 'UTF-8')
	end

	def self.find_director(string)
		headers "Timestamp" => Time.now.rfc2822 + " GMT"
		@@timestamp = Time.now.rfc2822 + " GMT"

		stringtosign = "GET" + "\n" + "www.businessdata.govt.nz" + "\n" + "/data/app/ws/rest/companies/role/search/v1.0/size/200/type/DIR/#{string}" + "\n" + @@timestamp + "\n" + @@access_key + "\n" + "application/xml" + "\n"

		headers "Authorization" => @@access_key + ":" + Base64.strict_encode64(OpenSSL::HMAC.digest('sha256', @@secret_key, stringtosign))

		Nokogiri::XML((get("/data/app/ws/rest/companies/role/search/v1.0/size/200/type/DIR/#{string}").body), 'UTF-8')

	end

	def self.find_company(id)
		headers "Timestamp" => Time.now.rfc2822 + " GMT"
		@@timestamp = Time.now.rfc2822 + " GMT"

		stringtosign = "GET" + "\n" + "www.businessdata.govt.nz" + "\n" + "/data/app/ws/rest/companies/entity/v2.0/#{id}" + "\n" + @@timestamp + "\n" + @@access_key + "\n" + "application/xml" + "\n"

		headers "Authorization" => @@access_key + ":" + Base64.strict_encode64(OpenSSL::HMAC.digest('sha256', @@secret_key, stringtosign))

		Nokogiri::XML((get("/data/app/ws/rest/companies/entity/v2.0/#{id}").body), 'UTF-8')

	end



	def self.tagged(tag)
		retrieve_url get("/#{tag}.json")
	end



end

